{-# LANGUAGE EmptyDataDecls, FlexibleContexts, FlexibleInstances,
  ForeignFunctionInterface, IncoherentInstances,
  MultiParamTypeClasses, OverlappingInstances, TemplateHaskell,
  TypeFamilies, TypeSynonymInstances #-}
module OGDF.FastSimpleHierarchyLayout.Implementation where
import Data.Monoid
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import Language.Haskell.TH
import Language.Haskell.TH.Syntax
import System.IO.Unsafe
import FFICXX.Runtime.Cast
import FFICXX.Runtime.CodeGen.Cxx
import FFICXX.Runtime.TH
import OGDF.FastSimpleHierarchyLayout.RawType
import OGDF.FastSimpleHierarchyLayout.FFI
import OGDF.FastSimpleHierarchyLayout.Interface
import OGDF.FastSimpleHierarchyLayout.Cast
import OGDF.FastSimpleHierarchyLayout.RawType
import OGDF.FastSimpleHierarchyLayout.Cast
import OGDF.FastSimpleHierarchyLayout.Interface
import STD.Deletable.RawType
import STD.Deletable.Cast
import STD.Deletable.Interface
import OGDF.HierarchyLayoutModule.RawType
import OGDF.HierarchyLayoutModule.Cast
import OGDF.HierarchyLayoutModule.Interface

instance () =>
         IFastSimpleHierarchyLayout (FastSimpleHierarchyLayout)
         where

instance () => IDeletable (FastSimpleHierarchyLayout) where
        delete = xform0 c_fastsimplehierarchylayout_delete

instance () => IHierarchyLayoutModule (FastSimpleHierarchyLayout)
         where

newFastSimpleHierarchyLayout :: () => IO FastSimpleHierarchyLayout
newFastSimpleHierarchyLayout
  = xformnull
      c_fastsimplehierarchylayout_newfastsimplehierarchylayout

fastSimpleHierarchyLayout_layerDistance ::
                                          () => FastSimpleHierarchyLayout -> CDouble -> IO ()
fastSimpleHierarchyLayout_layerDistance
  = xform1
      c_fastsimplehierarchylayout_fastsimplehierarchylayout_layerdistance

fastSimpleHierarchyLayout_nodeDistance ::
                                         () => FastSimpleHierarchyLayout -> CDouble -> IO ()
fastSimpleHierarchyLayout_nodeDistance
  = xform1
      c_fastsimplehierarchylayout_fastsimplehierarchylayout_nodedistance

fastSimpleHierarchyLayout_downward ::
                                     () => FastSimpleHierarchyLayout -> CBool -> IO ()
fastSimpleHierarchyLayout_downward
  = xform1
      c_fastsimplehierarchylayout_fastsimplehierarchylayout_downward

fastSimpleHierarchyLayout_leftToRight ::
                                        () => FastSimpleHierarchyLayout -> CBool -> IO ()
fastSimpleHierarchyLayout_leftToRight
  = xform1
      c_fastsimplehierarchylayout_fastsimplehierarchylayout_lefttoright

fastSimpleHierarchyLayout_balanced ::
                                     () => FastSimpleHierarchyLayout -> CBool -> IO ()
fastSimpleHierarchyLayout_balanced
  = xform1
      c_fastsimplehierarchylayout_fastsimplehierarchylayout_balanced
